<?php
// PHP 5 zemberek-server erişimi  (31/08/2008)
// Yazar : İsmail Ata KURT

class zemberek extends zemberek_server {
	
	public function denetle($kelime) {
		$check=$this->kontrol($kelime);
		
		if($check) {
			if($check=="1 *") {
    			return true;
			} else {    		
				return  explode(",",$this->oner($kelime));
			}
		} else {
			return ($this->soket_hatasi);
		}
	}
}

class zemberek_server {
	
	private $baglanti,$host,$port,$timeout,$errno,$errstr;
	protected $soket_hatasi=false;	
	
	function __construct($host='localhost',$port=10444,$timeout=10) {				
		$this->host=$host;
		$this->port=$port;
		$this->timeout=$timeout;		
	}
	
	public function kontrol($kelime) {
		$this->baglan();
		if($this->soket_hatasi()) return false;

		try {
			fputs($this->baglanti, (strlen($kelime)+2).' * '.$kelime);
			$response = stream_get_contents($this->baglanti,3);				
		} catch (Exception $e) {
			die($e);
		}
				 
		$this->baglanti_kes();
		return $response;
	}
	
	public function oner($kelime) {
		$this->baglan();
		if($this->soket_hatasi()) return false;
		
		try {
			fputs($this->baglanti, (strlen($kelime)+2).' & '.$kelime);			
			
			$response_length = trim(str_replace("&",'',stream_get_contents($this->baglanti,3)));      		
      		
			if($response_length=="1 ?"||$response_length=="1 #") {
      			return $kelime; // Hata - öneri yapılamıyor
      		}
      		      		
      		$response = str_replace(")","",substr(stream_get_contents($this->baglanti,$response_length),4));      		
      		
		} catch (Exception $e) {
			die($e);
		}
		
      	$this->baglanti_kes();
      	return $response;
	}
	
	private function baglan() {		
			$this->baglanti = 
			@fsockopen	(	$this->host, 
							$this->port, 
							$this->errno, 
							$this->errstr,
							$this->timeout);
	}
	
	private function baglanti_kes() {
		try {
			fclose($this->baglanti);
		} catch (Exception $e) {
			die($e);
		}
	}
	
	private function soket_hatasi() {
		if(!$this->baglanti) {
			$this->soket_hatasi= 
				array(
						'errno'=>$this->errno , // hata kodu
						'errstr'=>$this->errstr	 // hata mesajı
						);
			return true;
		} else {
			return false;
		}
	}
	
	private function zamanasimi($saniye) {
		$this->timeout=$saniye;
		try {
			stream_set_timeout($this->baglanti,$this->timeout);		
		} catch (Exception $e) {
			die($e);
		}		
	}	
	
}